Add support for IDE controllers with identity crisis
[yaboot.git] / ybin / ofpath
1 #! /bin/sh
2
3 ###############################################################################
4 ##
5 ## ofpath: determine OpenFirmware path from unix device node
6 ## Copyright (C) 2000, 2001, 2002 Ethan Benson
7 ##
8 ## Portions based on show_of_path.sh:
9 ##
10 ## Copyright (C) 2000 Olaf Hering <olh@suse.de>
11 ## 
12 ## This program is free software; you can redistribute it and/or
13 ## modify it under the terms of the GNU General Public License
14 ## as published by the Free Software Foundation; either version 2
15 ## of the License, or (at your option) any later version.
16 ##
17 ## This program is distributed in the hope that it will be useful,
18 ## but WITHOUT ANY WARRANTY; without even the implied warranty of
19 ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
20 ## GNU General Public License for more details.
21 ##
22 ## You should have received a copy of the GNU General Public License
23 ## along with this program; if not, write to the Free Software
24 ## Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
25 ##
26 ###############################################################################
27
28 PATH="/sbin:/bin:/usr/sbin:/usr/bin:/usr/local/sbin:/usr/local/bin"
29 PRG="${0##*/}"
30 VERSION=1.0.3-rc2
31 DEBUG=0
32 export LC_COLLATE=C
33
34 ## --version output.
35 version()
36 {
37 echo \
38 "$PRG $VERSION
39 Written by Ethan Benson
40 Portions based on show_of_path.sh written by Olaf Hering
41
42 Copyright (C) 2000, 2001, 2002 Ethan Benson
43 Portions Copyright (C) 2000 Olaf Hering
44 This is free software; see the source for copying conditions.  There is NO
45 warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE."
46 }
47
48 ## --help output.
49 usage()
50 {
51 echo \
52 "Usage: $PRG [OPTION]... FILE
53 Find OpenFirmware device path from unix device node.
54
55       --debug                print boring junk only useful for debugging
56   -h, --help                 display this help and exit
57   -V, --version              output version information and exit"
58 }
59
60 ## a small seq replacement, seq is not present on boot/rescue floppies.
61 smallseq()
62 {
63     local v="$1"
64     local n=1
65     echo 1
66     while [ "$v" -gt 1 ] ; do
67         echo "$(($n + 1))"
68         local n="$(($n + 1))"
69         local v="$(($v - 1))"
70     done
71     return 0
72 }
73
74 ## a kludge to replace wc -l, wc is not present on boot/rescue
75 ## floppies. max file is 145 lines, 3 hosts * 16 devs each * 3 lines
76 ## per device, + 1 "Attached Devices:" line.
77 linecount()
78 {
79     if [ $# = 0 ] ; then
80         local file="$(cat)"
81         local v="$file"
82     else
83         local file="$(cat $1)"
84         local v="$file"
85     fi
86
87     if [ -z "$file" ] ; then
88         echo 0
89         return 0
90     fi
91
92     ## use real wc if available
93     if (command -v wc > /dev/null 2>&1) ; then
94         if [ -x `command -v wc` ] ; then
95             lines="$(echo "$file" | wc -l)"
96             if [ $? = 0 ] ; then
97                 echo $lines
98                 unset lines
99                 return 0
100             fi
101         fi
102     fi
103
104     while true ; do
105         for i in `smallseq 145` ; do
106             local b="$(echo "$file" | tail -n $i)"
107             if [ "$v" = "$b" ] ; then
108                 echo "$i"
109                 break 2
110             fi
111         done
112     done
113     return 0
114 }
115
116 ## small tr replacment which handles a specific need of this script.
117 smalltr()
118 {
119     case "$1" in 
120         a) echo 1 ;; b) echo 2 ;; c) echo 3 ;; d) echo 4 ;; e) echo 5 ;; f) echo 6 ;;
121         g) echo 7 ;; h) echo 8 ;; i) echo 9 ;; j) echo 10 ;; k) echo 11 ;; l) echo 12 ;;
122         m) echo 13 ;; n) echo 14 ;; o) echo 15 ;; p) echo 16 ;;
123         1) echo a ;; 2) echo b ;; 3) echo c ;; 4) echo d ;; 5) echo e ;; 
124         6) echo f ;; 7) echo g ;; 8) echo h ;; 9) echo i ;; 10) echo j ;;
125         11) echo k ;; 12) echo l ;; 13) echo m ;; 14) echo n ;; 15) echo o ;;
126         16) echo p ;;
127     esac
128     return 0
129 }
130
131 ## replacment for grep -l which is not supported by busybox grep.
132 ## echo $(cat..) hack needed because busybox grep barfs with `line too
133 ## long' when fed /proc files.  the for loop is needed since busybox
134 ## grep seems to have somewhat broken regexp support.
135 ## usage: lgrep filename regexp regexp ...
136 lgrep()
137 {
138     local f="$1"
139     shift
140     for i in "$@" ; do
141         echo "$(cat "$f")" | grep -q "$i" && echo "$f" && break
142     done
143     return 0
144 }
145
146 ## if readlink is missing use a kludge
147 if (command -v readlink > /dev/null 2>&1) ; then
148     true
149 else
150     readlink()
151     {
152         local SYMTARGET="$(v=`ls -l "$2" 2>/dev/null` ; echo ${v##*> })"
153         if [ -n "$SYMTARGET" ] ; then
154             echo "$SYMTARGET"
155             return 0
156         else
157             return 1
158         fi
159     }
160 fi
161
162 ## a function to print relevant scsi host path when there is more then
163 ## one.  this function also takes care of stripping off the trailing
164 ## /compatible.
165 printhost()
166 {
167     case "$1" in
168         1)
169         echo "${2%/*}"
170         ;;
171         2)
172         echo "${3%/*}"
173         ;;
174         3)
175         echo "${4%/*}"
176         ;;
177         4)
178         echo "${5%/*}"
179         ;;
180     esac
181     return 0
182 }
183
184 ## this finds information we need on both newworld and oldworld macs.
185 ## mainly what scsi host a disk is attached to.
186 scsiinfo()
187 {
188     ## see if system has scsi at all
189     if [ ! -f /proc/scsi/scsi ] ; then
190         echo 1>&2 "$PRG: /dev/$DEVNODE: Device not configured"
191         return 1
192     fi
193
194     ## first we have to figure out the SCSI ID, have to do that
195     ## anyway [to] find the attached scsi disks = "Direct-Access" and
196     ## stop at sda=1 sdb=2 or whatever count in 3 lines steps
197
198     ## get last letter of device node, ie sda -> a
199     SUBNODE=${DEVNODE##*sd}
200
201     ## turn SUBNODE above into a number starting at 1, ie a -> 1
202     SUBDEV="$(smalltr $SUBNODE)"
203     [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: SUBNODE=$SUBNODE SUBDEV=$SUBDEV"
204
205     DEVCOUNT=0
206
207     ## copy scsi file into a variable removing "Attached Devices"
208     ## which is the first line. this avoids a lot of
209     ## [incmopatible] crap later, and improves readability.
210
211     ## find number of lines once and recycle that number, to save
212     ## some time (linecount is a bit slow). subtract one line
213     ## to scrap Attached Devices:
214
215     SCSILINES="$(($(linecount /proc/scsi/scsi) - 1))"
216
217     if [ "$SUBDEV" -gt "$(cat /proc/scsi/scsi | grep Direct-Access | linecount)" ] ; then
218         echo 1>&2 "$PRG: /dev/$DEVNODE: Device not configured"
219         return 1
220     fi
221
222     PROCSCSI="$(cat /proc/scsi/scsi | tail -n $SCSILINES)"
223
224     for i in $(smallseq $(($SCSILINES / 3))) ; do
225
226         ## put every scsi device into one single line
227         DEVINFO="$(echo "$PROCSCSI" | head -n $(($i * 3)) | tail -n 3)"
228         [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: DEVINFO=$DEVINFO"
229
230         ## cut the type field, expect "Direct-Access" later.
231         DEVTYPE="$(v=$(echo ${DEVINFO##*Type: }) ; echo ${v%% *})"
232         [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: DEVTYPE=$DEVTYPE"
233
234         ## get the device id.
235         DEVID="$(v=$(echo ${DEVINFO##*Id: }) ; n=$(echo ${v%% *}) ; echo ${n#*0})"
236         [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: DEVID=$DEVID"
237
238         ## get the scsi host id.
239         DEVHOST="$(v=$(echo ${DEVINFO##*Host: scsi}) ; echo ${v%% *})"
240         [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: DEVHOST=$DEVHOST"
241
242         if [ "$DEVTYPE" = "Direct-Access" ] ; then
243             DEVCOUNT="$(($DEVCOUNT + 1))"
244             [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: DEVCOUNT=$DEVCOUNT"
245             if [ "$SUBDEV" = "$DEVCOUNT" ] ; then
246                 DEVICE_HOST=$DEVHOST
247                 DEVICE_ID=$DEVID
248                 [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: DEVICE_HOST=$DEVICE_HOST"
249                 break
250             fi
251         fi
252     done
253
254     ## figure out what the scsi driver is, it is /proc/scsi/dirname.
255     [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: DEVICE_HOST=$DEVICE_HOST"
256     SCSI_DRIVER="$(x=`ls /proc/scsi/*/$DEVICE_HOST 2>/dev/null | cat` ; y=`echo ${x##*proc/scsi/}` ; echo ${y%%/*})"
257     [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: SCSI_DRIVER=$SCSI_DRIVER"
258
259     ## figure out which host we found.
260     SCSI_HOSTNUMBER="$(v=`ls /proc/scsi/$SCSI_DRIVER/* 2>/dev/null | cat | grep -n "$DEVICE_HOST\>"` ; echo ${v%%:*})"
261     [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: SCSI_HOSTNUMBER=$SCSI_HOSTNUMBER"
262
263     return 0
264 }
265
266 ## generic function that can find OF device paths for scsi devices,
267 ## must be run after scsiinfo().
268 scsi_ofpath()
269 {
270     case "$SCSI_DRIVER" in
271         aic7xxx)
272             HOST_LIST="$(for i in `find /proc/device-tree -name compatible` ; do
273                         lgrep "$i" "^ADPT" "^pci900[45]" "^pciclass,01000" ; done)"
274             DEVICE_PATH="$(printhost $SCSI_HOSTNUMBER $HOST_LIST)"
275             echo "${DEVICE_PATH##*device-tree}/@$DEVICE_ID:$PARTITION"
276             ;;
277         sym53c8xx)
278             HOST_LIST="$(for i in `find /proc/device-tree -name compatible` ; do
279                         lgrep "$i" "^Symbios" "^pci1000" "^pciclass,01000" ; done)"
280             DEVICE_PATH="$(printhost $SCSI_HOSTNUMBER $HOST_LIST)"
281             echo "${DEVICE_PATH##*device-tree}/@$DEVICE_ID:$PARTITION"
282             ;;
283         mesh)
284             HOST_LIST="$(for i in `find /proc/device-tree -name compatible` ; do
285                         lgrep "$i" "mesh" ; done)"
286             DEVICE_PATH="$(printhost $SCSI_HOSTNUMBER $HOST_LIST)"
287             echo "${DEVICE_PATH##*device-tree}/@$DEVICE_ID:$PARTITION"
288             ;;
289         *)
290             echo 1>&2 "$PRG: Driver: $SCSI_DRIVER is not supported"
291             return 1
292             ;;
293     esac
294     return 0
295 }
296
297 ide_ofpath()
298 {
299     if [ ! -L "/proc/ide/$DEVNODE" ] ; then
300         echo 2>&1 "$PRG: /dev/$DEVNODE: Device not configured"
301         return 1
302     fi
303
304     local IDEBUS="$(v=`readlink /proc/ide/$DEVNODE` ; echo ${v%%/*} )"
305     if [ -z "$IDEBUS" ] ; then
306         echo 1>&2 "$PRG: BUG: IDEBUS == NULL"
307         return 1
308     fi
309     local OF1275IDE="/proc/ide/$IDEBUS/devspec"
310
311     if [ ! -f "$OF1275IDE" ] ; then
312         case "$(cat /proc/device-tree/model)" in
313             "PowerMac3,6")
314                 local CDROM="$(grep "^drive name:" /proc/sys/dev/cdrom/info 2> /dev/null | grep $DEVNODE)"
315                 if [ -z "$CDROM" ] ; then
316                     echo "ultra2:$PARTITION"
317                 else
318                     echo "cd:$PARTITION"
319                 fi
320                 ;;
321             *)
322                 local CDROM="$(grep "^drive name:" /proc/sys/dev/cdrom/info 2> /dev/null | grep $DEVNODE)"
323                 if [ -z "$CDROM" ] ; then
324                     if [ "$DEVNODE" = hda ] ; then
325                         echo "hd:$PARTITION"
326                     else
327                         echo "ultra1:$PARTITION"
328                     fi
329                 else
330                     echo "cd:$PARTITION"
331                 fi
332                 ;;
333         esac
334     else
335         local DEVSPEC="$(cat $OF1275IDE)"
336         [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: DEVSPEC=$DEVSPEC"
337         if [ -z "$DEVSPEC" ] ; then
338             echo 1>&2 "$PRG: KERNEL BUG: $OF1275IDE exists, but is empty"
339             return 1
340         fi
341
342         if [ ! -f "/proc/ide/${IDEBUS}/channel" ] ; then
343             echo 1>&2 "$PRG: KERNEL BUG: /proc/ide/${IDEBUS}/channel does not exist"
344             return 1
345         fi
346
347         case "$(cat /proc/device-tree${DEVSPEC}/device_type 2> /dev/null)" in
348             ata)
349                 local MASTER="/disk@0"
350                 local SLAVE="/disk@1"
351                 ;;
352             pci-ata)
353                 local MASTER="/@$(cat /proc/ide/${IDEBUS}/channel)/disk@0"
354                 local SLAVE="/@$(cat /proc/ide/${IDEBUS}/channel)/disk@1"
355                 ;;
356             scsi) ## some lame controllers pretend they are scsi, hopefully all kludges are created equal.
357                 local MASTER="/$(($(cat /proc/ide/${IDEBUS}/channel) * 2 + 0)),0"
358                 local SLAVE="/$(($(cat /proc/ide/${IDEBUS}/channel) * 2 + 1)),0"
359                 ;;
360             *)
361                 echo 2>&1 "$PRG: Unsupported IDE device type: \"$(cat /proc/device-tree${DEVSPEC}/device_type 2> /dev/null)\""
362                 return 1
363                 ;;
364         esac
365
366         case "$DEVNODE" in
367             hda|hdc|hde|hdg|hdi)
368                 echo "${DEVSPEC}${MASTER}:$PARTITION"
369                 return 0
370                 ;;
371             hdb|hdd|hdf|hdh|hdj)
372                 echo "${DEVSPEC}${SLAVE}:$PARTITION"
373                 return 0
374                 ;;
375             *)
376                 echo 1>&2 "$PRG: /dev/$DEVNODE is not supported"
377                 return 1
378                 ;;
379         esac
380     fi
381 }
382
383 ## figure out the OpenFirmware device path for newworld macs.
384 ## sd* scsi disks , hd* ide disks.
385 newworld()
386 {
387     case "$DEVNODE" in
388         sd*)
389             if ls -l /proc/device-tree | grep -q ^lr ; then
390                 true
391             else
392                 echo 1>&2 "$PRG: /proc/device-tree is broken.  Do not use BootX to boot, use yaboot."
393                 echo 1>&2 "$PRG: The yaboot HOWTO can be found here: http://www.alaska.net/~erbenson/doc"
394                 return 1
395             fi
396
397             ## use common scsiinfo function to get info we need.
398             scsiinfo || return 1
399
400             ## now we have the data for /@$DEVID:$PARTITION
401             ## find the actual OF path. 
402             scsi_ofpath || return 1
403             ;;
404         hd*)
405             ide_ofpath || return 1
406             ;;
407         *)
408             echo 1>&2 "$PRG: Device: /dev/$DEVNODE is not supported"
409             return 1
410             ;;
411     esac
412     return 0
413 }
414
415 oldworld()
416 {
417     ## for some reason 2.4 kernels put OF aliases in aliases@0/ instead of plain aliases/
418     if [ -d "/proc/device-tree/aliases" ] ; then
419         local ALIASES="aliases"
420     elif [ -d "/proc/device-tree/aliases@0" ] ; then
421         local ALIASES="aliases@0"
422     else
423         echo 1>&2 "$PRG: Cannot find OpenFirmware aliases directory in /proc/device-tree/"
424         return 1
425     fi
426
427     local MODEL="$(cat /proc/device-tree/compatible)"
428     [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: Oldworld subarch: $MODEL"
429
430     case "$MODEL" in
431         AAPL,7300*|AAPL,7500*|AAPL,8500*|AAPL,9500*|AAPL,\?\?\?\?*)
432             case "$DEVNODE" in
433                 sd*)
434                 scsiinfo || return 1
435                 case "$SCSI_DRIVER" in
436                     mesh)
437                     echo $(cat /proc/device-tree/$ALIASES/scsi-int)/sd\@$DEVICE_ID:$PARTITION
438                     ;;
439                     53c94)
440                     echo $(cat /proc/device-tree/$ALIASES/scsi)/sd\@$DEVICE_ID:$PARTITION
441                     ;;
442                     *)
443                     echo 1>&2 "$PRG: Driver $SCSI_DRIVER is not supported"
444                     return 1
445                     ;;
446                 esac
447                 ;;
448                 *)
449                 echo 1>&2 "$PRG: Unsupported device: /dev/$DEVNODE"
450                 return 1
451                 ;;
452             esac
453             ;;
454         AAPL,e407*)
455             case "$DEVNODE" in
456                 sd*)
457                 scsiinfo || return 1
458                 case "$SCSI_DRIVER" in
459                     mesh)
460                     echo $(cat /proc/device-tree/$ALIASES/scsi)/sd\@$DEVICE_ID:$PARTITION
461                     ;;
462                     *)
463                     echo 1>&2 "$PRG: Driver $SCSI_DRIVER is not supported"
464                     return 1
465                     ;;
466                 esac
467                 ;;
468                 hda*)
469                 echo $(cat /proc/device-tree/$ALIASES/ata)/ATA-Disk\@0:$PARTITION
470                 ;;
471                 hdb*)
472                 echo $(cat /proc/device-tree/$ALIASES/ata)/ATA-Disk\@1:$PARTITION
473                 ;;
474                 hd*)
475                 echo 1>&2 "$PRG: Device: /dev/$DEVNODE is not supported"
476                 ;;
477             esac
478             ;;
479         AAPL,e826*)
480             case "$DEVNODE" in
481                 sd*)
482                 scsiinfo || return 1
483                 case "$SCSI_DRIVER" in
484                     mesh)
485                     echo $(cat /proc/device-tree/$ALIASES/scsi)/sd\@$DEVICE_ID:$PARTITION
486                     ;;
487                     *)
488                     echo 1>&2 "$PRG: Driver $SCSI_DRIVER is not supported"
489                     return 1
490                     ;;
491                 esac
492                 ;;
493                 hda*)
494                 echo $(cat /proc/device-tree/$ALIASES/ata)/ata-disk\@0:$PARTITION
495                 ;;
496                 hdb*)
497                 echo $(cat /proc/device-tree/$ALIASES/ata)/ata-disk\@1:$PARTITION
498                 ;;
499                 hd*)
500                 echo 1>&2 "$PRG: Device: /dev/$DEVNODE is not supported"
501                 ;;
502             esac
503             ;;
504         AAPL,Gossamer*|AAPL,PowerMac\ G3*)
505             case "$DEVNODE" in
506                 sd*)
507                 scsiinfo || return 1
508                 case "$SCSI_DRIVER" in
509                     mesh)
510                     echo $(cat /proc/device-tree/$ALIASES/scsi)/sd\@$DEVICE_ID:$PARTITION
511                     ;;
512                     *)
513                     echo 1>&2 "$PRG: Driver $SCSI_DRIVER is not supported"
514                     return 1
515                     ;;
516                 esac
517                 ;;
518                 hda*)
519                 echo $(cat /proc/device-tree/$ALIASES/ide0)/ata-disk\@0:$PARTITION
520                 ;;
521                 hdb*)
522                 echo $(cat /proc/device-tree/$ALIASES/ide0)/ata-disk\@1:$PARTITION
523                 ;;
524                 hdc*)
525                 echo $(cat /proc/device-tree/$ALIASES/ide1)/ata-disk\@0:$PARTITION
526                 ;;
527                 hdd*)
528                 echo $(cat /proc/device-tree/$ALIASES/ide1)/ata-disk\@1:$PARTITION
529                 ;;
530                 hd*)
531                 echo 1>&2 "$PRG: Device: /dev/$DEVNODE is not supported"
532                 ;;
533             esac
534             ;;
535         AAPL,PowerBook1998*)
536             if [ -f  /proc/device-tree/$ALIASES/ata0 ] ; then
537                 local ATA0=ata0
538             else
539                 local ATA0=ide0
540             fi
541             if [ -f  /proc/device-tree/$ALIASES/ata1 ] ; then
542                 local ATA1=ata1
543             else
544                 local ATA1=bay-ata1
545             fi
546             case "$DEVNODE" in
547                 sd*)
548                 scsiinfo || return 1
549                 case "$SCSI_DRIVER" in
550                     mesh)
551                     echo $(cat /proc/device-tree/$ALIASES/scsi)/sd\@$DEVICE_ID:$PARTITON
552                     ;;
553                     *)
554                     echo 1>&2 "$PRG: Driver $SCSI_DRIVER is not supported"
555                     return 1
556                     ;;
557                 esac
558                 ;;
559                 hda*)
560                 echo $(cat /proc/device-tree/$ALIASES/$ATA0)/ata-disk\@0:$PARTITION
561                 ;;
562                 hdb*)
563                 echo $(cat /proc/device-tree/$ALIASES/$ATA0)/ata-disk\@1:$PARTITION
564                 ;;
565                 hdc*)
566                 echo $(cat /proc/device-tree/$ALIASES/$ATA1)/atapi-disk\@0:$PARTITION
567                 ;;
568                 hdd*)
569                 echo $(cat /proc/device-tree/$ALIASES/$ATA1)/atapi-disk\@1:$PARTITION
570                 ;;
571                 *)
572                 echo 1>&2 "$PRG: Unsupported device: /dev/$DEVNODE"
573                 return 1
574                 ;;
575             esac
576             ;;
577         AAPL,3400/2400*)
578             case "$DEVNODE" in
579                 sd*)
580                 scsiinfo || return 1
581                 case "$SCSI_DRIVER" in
582                     mesh)
583                     echo $(cat /proc/device-tree/$ALIASES/scsi-int)/sd\@$DEVICE_ID:$PARTITON
584                     ;;
585                     53c94)
586                     echo $(cat /proc/device-tree/$ALIASES/scsi)/sd\@$DEVICE_ID:$PARTITON
587                     ;;
588                     *)
589                     echo 1>&2 "$PRG: Driver $SCSI_DRIVER is not supported"
590                     return 1
591                     ;;
592                 esac
593                 ;;
594                 hda*)
595                 echo $(cat /proc/device-tree/$ALIASES/ata0)/ata-disk\@0:$PARTITION
596                 ;;
597                 hdb*)
598                 echo $(cat /proc/device-tree/$ALIASES/ata0)/ata-disk\@1:$PARTITION
599                 ;;
600                 hdc*)
601                 echo $(cat /proc/device-tree/$ALIASES/ata1)/atapi-disk\@0:$PARTITION
602                 ;;
603                 hdd*)
604                 echo $(cat /proc/device-tree/$ALIASES/ata1)/atapi-disk\@1:$PARTITION
605                 ;;
606                 hde*)
607                 echo $(cat /proc/device-tree/$ALIASES/ata2):$PARTITION
608                 ;;
609                 hdf*)
610                 echo $(cat /proc/device-tree/$ALIASES/ata3):$PARTITION
611                 ;;
612                 *)
613                 echo 1>&2 "$PRG: Unsupported device: /dev/$DEVNODE"
614                 return 1
615                 ;;
616             esac
617             ;;
618         *)
619             echo 1>&2 "$PRG: This machine is not supported: $MODEL"
620             return 1
621             ;;
622     esac
623     return 0
624 }
625
626 ## find OpenFirmware device path for IBM CHRP hardware (scsi only)
627 chrp()
628 {
629     case "$DEVNODE" in
630         sd*)
631             if ls -l /proc/device-tree | grep -q ^lr ; then
632                 true
633             else
634                 echo 1>&2 "$PRG: /proc/device-tree is broken."
635                 return 1
636             fi
637
638             ## use common scsiinfo function to get info we need.
639             scsiinfo || return 1
640
641             ## now we have the data for /@$DEVID:$PARTITION
642             ## find the actual OF path. 
643             scsi_ofpath || return 1
644             ;;
645         *)
646             echo 1>&2 "$PRG: Device: /dev/$DEVNODE is not supported"
647             return 1
648             ;;
649     esac
650     return 0
651 }
652
653 ## If we get lame devfs name, we need to make it foad
654 ckdevfs()
655 {
656     case "$1" in
657         /dev/ide/*|/dev/scsi/*|/dev/discs/*)
658         return 0
659         ;;
660         *)
661         return 1
662         ;;
663     esac
664 }
665
666 ## convert devfs names into normal short ones, written by Tom Rini.
667 fixdevfs()
668 {
669     ## get partition number, if any
670     local PARTNUM="${1##*[a-z]}"
671     ## Find the bus type.
672     local TYPE="$(v=${1#/dev/} ; echo ${v%/host*})"
673     ## Find the host number.
674     local HOST="$(v=${1#/dev/*/host} ; echo ${v%/bus*})"
675     ## Find the bus number.
676     local BUS="$(v=${1#/dev/*/bus} ; echo ${v%/tar*})"
677     ## Find the target.
678     local TARGET="$(v=${1#/dev/*/target} ; echo ${v%/lun*})"
679
680     case "$TYPE" in
681         ide)
682         case "$HOST" in
683             0)
684             case "$TARGET" in
685                 0)
686                 local DEV=hda
687                 ;;
688                 1)
689                 local DEV=hdb
690                 ;;
691             esac
692             ;;
693             1)
694             case "$TARGET" in
695                 0)
696                 local DEV=hdc
697                 ;;
698                 1)
699                 local DEV=hdd
700                 ;;
701             esac
702             ;;
703             *)
704                 echo 1>&2 "$PRG: $1: Unable to translate this device, try again without devfs."
705                 return 1
706         esac
707         local DEV="${DEV}${PARTNUM}"
708         echo "/dev/$DEV"
709         return 0
710         ;;
711         scsi)
712         local LUN="$(v=${1#/dev/*/lun} ; echo ${v%/*})"
713
714         ## In this case, we need to figure out what number our device is
715         local DEVCOUNT=0
716
717         ## copy scsi file into a variable removing "Attached Devices"
718         ## which is the first line. this avoids a lot of
719         ## [incmopatible] crap later, and improves readability.
720
721         ## find number of lines once and recycle that number, to save
722         ## some time (linecount is a bit slow). subtract one line
723         ## to scrap Attached Devices:
724
725         local SCSILINES="$(($(linecount /proc/scsi/scsi) - 1))"
726         local PROCSCSI="$(cat /proc/scsi/scsi | tail -n $SCSILINES)"
727
728         for i in $(smallseq $(($SCSILINES / 3))) ; do
729
730             ## put every scsi device into one single line
731             local DEVINFO="$(echo "$PROCSCSI" | head -n $(($i * 3)) | tail -n 3)"
732             [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: fixdevfs: DEVINFO=$DEVINFO"
733
734             ## cut the type field, expect "Direct-Access" later.
735             local DEVTYPE="$(v=$(echo ${DEVINFO##*Type: }) ; echo ${v%% *})"
736             [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: fixdevfs: DEVTYPE=$DEVTYPE"
737
738             if [ "$DEVTYPE" = "Direct-Access" ] ; then
739                 ## Lets find out some more information
740                 ## get the device id.
741                 local DEVID="$(v=$(echo ${DEVINFO##*Id: }) ; n=$(echo ${v%% *}) ; echo ${n#*0})"
742                 [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: fixdevfs: DEVID=$DEVID"
743
744                 ## get the device lun.
745                 local DEVLUN="$(v=$(echo ${DEVINFO##*Lun: }) ; n=$(echo ${v%% *}) ; echo ${n#*0})"
746                 [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: fixdevfs: DEVLUN=$DEVLUN"
747
748                 ## get the device channel.
749                 local DEVCHAN="$(v=$(echo ${DEVINFO##*Channel: }) ; n=$(echo ${v%% *}) ; echo ${n#*0})"
750                 [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: fixdevfs: DEVCHAN=$DEVCHAN"
751
752                 ## get the scsi host id.
753                 local DEVHOST="$(v=$(echo ${DEVINFO##*Host: scsi}) ; echo ${v%% *})"
754                 [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: fixdevfs: DEVHOST=$DEVHOST"
755
756                 local DEVCOUNT="$(($DEVCOUNT + 1))"
757                 [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: fixdevfs: DEVCOUNT=$DEVCOUNT"
758                 if [ "$DEVHOST" = "$HOST" -a "$DEVCHAN" = "$BUS" -a \
759                     "$DEVID" = "$TARGET" -a "$DEVLUN" = "$LUN" ] ; then
760                     local DEV="sd$(smalltr $DEVCOUNT)${PARTNUM}"
761                     echo "/dev/$DEV"
762                     return 0
763                 fi
764             fi
765         done
766         echo 1>&2 "$PRG: $1: Unable to translate this device, try again without devfs."
767         return 1
768         ;;
769         *)
770         echo 1>&2 "$PRG: Unknown bus $TYPE"
771         return 1
772         ;;
773     esac
774     ## we should never get here
775     return 1
776 }
777
778 ## make sure that find, head and tail can be found.  otherwise the
779 ## script will silently give bogus paths.  these are the only /usr/*
780 ## utilities this script depends on.
781 checkutils()
782 {
783     if command -v find > /dev/null 2>&1 ; then
784         [ -x `command -v find` ] || FAIL=1 ; else FAIL=1 ; fi
785     if command -v head > /dev/null 2>&1 ; then
786         [ -x `command -v head` ] || FAIL=1 ; else FAIL=1 ; fi
787     if command -v tail > /dev/null 2>&1 ; then
788         [ -x `command -v tail` ] || FAIL=1 ; else FAIL=1 ; fi
789
790     if [ "$FAIL" = 1 ] ; then
791         echo 1>&2 "$PRG: \`find', \`head', or \`tail' could not be found, aborting."
792         return 1
793     else
794         return 0
795     fi
796 }
797
798 ## parse command line switches.
799 if [ $# != 0 ] ; then
800     while true ; do
801         case "$1" in
802             -V|--version)
803                 version
804                 exit 0
805                 ;;
806             -h|--help)
807                 usage
808                 exit 0
809                 ;;
810             --debug)
811                 DEBUG=1
812                 shift
813                 ;;
814             -*)
815                 echo 1>&2 "$PRG: unrecognized option \`$1'"
816                 echo 1>&2 "$PRG: Try \`$PRG --help' for more information."
817                 exit 1
818                 ;;
819             "")
820                 echo 1>&2 "$PRG: You must specify a filename"
821                 echo 1>&2 "Try \`$PRG --help' for more information."
822                 exit 1
823                 ;;
824             *)
825                 device="$1"
826                 break
827                 ;;
828         esac
829     done
830 else
831     echo 1>&2 "$PRG: You must specify a /dev device"
832     echo 1>&2 "Try \`$PRG --help' for more information."
833     exit 1
834 fi
835
836 ## check that FILE is a block device and exists.
837 if [ ! -e "$device" ] ; then
838     echo 1>&2 "$PRG: $device: No such file or directory"
839     exit 1
840 elif [ ! -b "$device" ] ; then
841     echo 1>&2 "$PRG: $device is not a block device"
842     exit 1
843 fi
844
845 ## check that we are running on a GNU/Linux system, OSX/BSD does not
846 ## have the same /proc stuff
847 if [ `uname -s` != Linux ] ; then
848     echo 1>&2 "$PRG: This utility will only work with GNU/Linux"
849     exit 1
850 fi
851
852 ## check for ppc, i think uname -m is safe for this...
853 if [ `uname -m` != ppc ] ; then
854     echo 1>&2 "$PRG: This utility will only work on PowerPC hardware"
855     exit 1
856 fi
857
858 ## ofpath cannot live without procfs
859 if [ ! -f /proc/uptime ] ; then
860     echo 1>&2 "$PRG: This utility requires the /proc filesystem"
861     exit 1
862 fi
863
864 ## check for retarded devfs names and tell them to foad.
865 if ckdevfs "$device" ; then
866     device="$(fixdevfs $device)" || exit 1
867 fi
868
869 ## check for newworld mac. use cat hack due to /proc wierdness.
870 if [ "$(v=`cat /proc/cpuinfo 2>/dev/null | grep pmac-generation` ; echo ${v##*:[ ]})" = NewWorld ] ; then
871     SUBARCH=NewWorld
872 elif [ "$(v=`cat /proc/cpuinfo 2>/dev/null | grep pmac-generation` ; echo ${v##*:[ ]})" = OldWorld ] ; then
873     SUBARCH=OldWorld
874 elif (cat /proc/cpuinfo 2>/dev/null | grep ^motherboard | grep -q AAPL) ; then
875     SUBARCH=OldWorld
876 elif (cat /proc/cpuinfo 2> /dev/null | grep ^machine | grep -q 'CHRP IBM') ; then
877     SUBARCH=CHRP
878 else
879     echo 1>&2 "$PRG: This machine is not yet supported"
880     exit 1
881 fi
882
883 ## make sure /proc/device-tree exists
884 if [ ! -d /proc/device-tree ] ; then
885     echo 1>&2 "$PRG: /proc/device-tree does not exist"
886     echo 1>&2 "$PRG: Make sure you compiled your kernel with CONFIG_PROC_DEVICETREE=y"
887     exit 1
888 fi
889
890 ## make sure we have what we need.
891 checkutils || exit 1
892
893 ## get the base device node and scrap /dev/ ie /dev/hda2 -> hda
894 DEVICE="${device##*/}"
895 DEVNODE="${DEVICE%%[0-9]*}"
896 PARTITION="${DEVICE##*[a-z]}"
897
898 ## use appropriate search for right sub arch.
899 case "$SUBARCH" in
900     NewWorld)
901         newworld || exit 1
902         ;;
903     OldWorld)
904         oldworld || exit 1
905         ;;
906     CHRP)
907         chrp || exit 1
908         ;;
909 esac
910
911 exit 0